
package de.ivu.elect.presentation.stimmeingabe.exchange;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.commons.lang3.StringUtils;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.control.NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext;
import de.ivu.elect.business.exchange.control.AbstractExporter;
import de.ivu.elect.business.gebietsbaum.boundary.GebietExtendedDAO;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.boundary.Eml510bImportiertExporter;
import de.ivu.elect.business.wahl.control.NlExportArtefaktNachSystemExportstatusExportObject;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.dokumente.ElectDokumentContextGenerator;
import de.ivu.elect.presentation.exchange.AbstractExportSearchView;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.wahl.exchange.AbstractNlExportArtefaktNachSystemExportstatusBulkExportDescription;

@OnlineHilfeId("TODO")
@Named(Eml510bImportiertExportView.COMPONENT_NAME)
@View(viewId = Eml510bImportiertExportView.VIEW_ID, useCase = UseCasePermission.CUSTOMER_3)
public class Eml510bImportiertExportView extends AbstractExportSearchView<NlExportArtefaktNachSystemExportstatusExportObject, NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "eml510bImportiertZipExportView";

  public static final String VIEW_ID = "/stimmeingabe/eml-510-b-importiert-export.xhtml";

  @Inject
  private transient Eml510bImportiertExportDescription exportDescription;

  @Inject
  private transient Eml510bImportiertExporter eml510bImportiertExporter;

  @Inject
  private transient GebietExtendedDAO gebietExtendedDAO;

  @Inject
  private transient ElectDokumentContextGenerator electDokumentContextGenerator;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  public Eml510bImportiertExportView() {
    super();
  }

  @Override
  @Nullable
  @PreConditionCheck
  public String checkPreCondition() {
    String result = super.checkPreCondition();
    if (StringUtils.isNotBlank(result)) {
      return result;
    }

    if (getSupportedFileFormats().isEmpty()) {
      return getStartViewId();
    }

    return null;
  }


  @Override
  public AbstractNlExportArtefaktNachSystemExportstatusBulkExportDescription getExportDescription() {
    return exportDescription;
  }

  @Override
  protected AbstractExporter<NlExportArtefaktNachSystemExportstatusExportObject, NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext> getExporter() {
    return eml510bImportiertExporter;
  }

  @Override
  protected NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext getContext() {
      return new NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext(electDokumentContextGenerator.createElectDokumentContext(),
        getWahlParameterLoader(), gebietExtendedDAO.findByWahl(getSelectedWahl()), ergebnisSessionSelect.getEntity());
  }

  @Override
  public boolean isSupportedFileFormatsRendered() {
    return super.isSupportedFileFormatsRendered() && getSupportedFileFormats().size() != 1;
  }
}
